# animal1 = {"name":"cat", "legs":4, "tail":True, "sound":"meow"}
# animal2 = {"name":"dog", "legs":4, "tail":True, "sound":"woof"}
# animal3 = {"name":"fish","legs":0, "tail":False, "sound":"blublub"}

# zoo = [animal1, animal2, animal3]
# for animal in zoo:
#     print(f"a {animal['name']} says {animal['sound']}")

# class Animal:
#     def __init__(self, name, legs, tail, sound):
#         self.name = name
#         self.legs = legs
#         self.tail = tail
#         self.sound = sound

#     def speak(self, n=1):
#         for i in range(n):
#             print(f"{self.name} says {self.sound}")
    
#     def __str__(self):
#         return f"I am a {self.name}, I have {self.legs} legs, it is {self.tail} that I have a tail, and the sound I make is {self.sound}"

# animal1 = Animal(name="dog", legs=4, tail=True, sound="woof")
# animal2 = Animal(name="cat", legs=4, tail=True, sound="meow")
# zoo = [animal1, animal2]
# for animal in zoo:
#     animal.speak(3)

# print(zoo[0])

# name = "Paul"
# print(name)
# print(name.upper())

# mylist = [2,3,4,3,2]
# mylist.sort()
# print(mylist)

# encapsulation

# inheritance

class Shape2D:
    def __init__(self, name):
        self.name = name

    def __str__(self):
        return f"I am a {self.name}"

    def __add__(self, other):
        return f"{self.name}{other.name}"

class Circle(Shape2D):
    def __init__(self, radius):
        super().__init__(name="circle")
        self.radius = radius
    
    def __str__(self): # override
        return super().__str__() + f" and I have radius {self.radius}"
    
    def area(self):
        return 3.14159 * self.radius * self.radius

class Rectangle(Shape2D):
    def __init__(self, l, w):
        super().__init__(name="rectangle")
        self.l = l
        self.w = w

    def __str__(self): # override
        return super().__str__() + f" and I have length {self.l} and width {self.w}"

    def area(self):
        return self.l * self.w

s1 = Circle(radius=5)
print(s1)
s2 = Rectangle(l=3, w=4)
print(s2)

shapes = [s1, s2]
for s in shapes:
    print(s.area())

print(s1 + s2)

# polymorphism (operator or function overload)


